PROC Configuration(CHAN OF SP fs, ts,
                   CHAN OF TO.SCSI tscsi,
                   CHAN OF FROM.SCSI fscsi)
  BOOL Going:
  INT  reply:
  SEQ
    Going := TRUE
    Execution.Status := SCSI.E.Good
    Clear.Screen(fs, ts)
    WHILE Going
      SEQ
        --{{{  Prompt User
        Display.Options(fs, ts,
                        Main.Title,
                        "IMS B422 Configuration",
                        ["Exit                    ",
                         "Reset Bus               ",
                         "Reset Controller        ",
                         "Invoke B422 Diagnostics ",
                         "Define Bus IDs          ",
                         "Display current settings",
                         "Define Parameters       "],
                         Status.Message,
                         reply)
        --}}}  
        --{{{  Do User request
        CASE reply
          0
            Going := FALSE
          1
            --{{{  Reset Bus
            SEQ
              SCSI.Initialise ( tscsi,
                                fscsi,
                                Data.Phase.Time.Out,
                                Interrupt.Time.Out,
                                Parity.Checking,
                                Parity.Generation,
                                Cable.Mode,
                                Do.Not.Reset.SCSI.Controller,
                                1 (BYTE), --Reset.SCSI.Bus,
                                Do.Not.Self.Test,
                                Execution.Status)
              Prepare.Status.Message(Execution.Status, Status.Message)
            --}}}  
          2
            --{{{  Reset Controller
            SEQ
              SCSI.Initialise ( tscsi,
                                fscsi,
                                Data.Phase.Time.Out,
                                Interrupt.Time.Out,
                                Parity.Checking,
                                Parity.Generation,
                                Cable.Mode,
                                Reset.SCSI.Controller,
                                Do.Not.Reset.SCSI.Bus,
                                Do.Not.Self.Test,
                                Execution.Status)
              Prepare.Status.Message(Execution.Status, Status.Message)
            --}}}  
          3
            --{{{  Self Test
            SEQ
              SCSI.Initialise ( tscsi,
                                fscsi,
                                Data.Phase.Time.Out,
                                Interrupt.Time.Out,
                                Parity.Checking,
                                Parity.Generation,
                                Cable.Mode,
                                Do.Not.Reset.SCSI.Controller,
                                Do.Not.Reset.SCSI.Bus,
                                Do.Self.Test,
                                Execution.Status)
              Prepare.Status.Message(Execution.Status, Status.Message)
            --}}}  
          4
            --{{{  Prompt operator for initiator and target SCSI device ID's
            BOOL First.Time:
            SEQ
              First.Time := TRUE
              Initiator.ID := 7 (BYTE)
              Target.ID := 7 (BYTE)
              WHILE (Initiator.ID = Target.ID)
                SEQ
                  IF
                    NOT First.Time
                      --{{{  Warning Message
                      so.write.string.nl(fs, ts, "Initiator ID and Target ID must be different.")
                      --}}}  
                    TRUE
                      First.Time := FALSE
                  --{{{  Prompt Operator for Initiator ID
                  INT reply:
                  SEQ
                    Quit := TRUE
                    so.ask(fs, ts,
                           "Which Initiator ID do you wish to set IMS B422 as > ",
                           "01234567",
                           TRUE,
                           TRUE,
                           reply)
                    Initiator.ID := BYTE reply
                    so.write.nl(fs, ts)
                    so.write.nl(fs, ts)
                  --}}}  
                  --{{{  Prompt Operator for Target ID
                  INT reply:
                  SEQ
                    Quit := TRUE
                    so.ask(fs, ts,
                           "Which Target ID do you wish IMS B422 to talk to   > ",
                           "01234567",
                           TRUE,
                           TRUE,
                           reply)
                    Target.ID := BYTE reply
                    so.write.nl(fs, ts)
                    so.write.nl(fs, ts)
                  --}}}  
              --{{{  Prompt Operator for LUN
              INT reply:
              SEQ
                Quit := TRUE
                so.ask(fs, ts,
                       "Which LUN do you wish IMS B422 to talk to   > ",
                       "01234567",
                       TRUE,
                       TRUE,
                       reply)
                LUN := BYTE reply
                so.write.nl(fs, ts)
                so.write.nl(fs, ts)
              --}}}  
              --{{{  Make IMS B422 an Initiator
              so.write.string.nl(fs, ts, "Make B422 an Initiator")
              Enable.Initiator.Mode( tscsi,
                                     fscsi,
                                     BYTE Initiator.ID,
                                     Execution.Status)
              --}}}  
              Prepare.Status.Message(Execution.Status, Status.Message)
            --}}}  
          5
            --{{{  Display Current Settings
            Display.Current.Settings(fs, ts)
            --}}}  
          6
            --{{{  Define Parameters
            Define.Parameters(fs, ts, tscsi, fscsi)
            --}}}  
          ELSE
            so.write.string.nl(fs, ts, "Not Implemented")
        --}}}  
:
