--{{{  interpret iterm line with 2 arguments
PROC interpret.iterm.2.arg (VAL INT arg1, arg2, []BYTE command, INT len)
  BOOL arg, adj:
  SEQ
    len := 0
    arg := FALSE
    adj := FALSE
    SEQ i=0 FOR SIZE s.goto
      IF
        arg
          --{{{  this item is an argument
          SEQ
            arg := FALSE
            adj := TRUE
          --}}}
        adj
          --{{{  this item is an adjustment
          --{{{  abbreviations
          VAL desc          IS INT s.goto[i-1]:
          VAL arg.no        IS desc / 10:
          VAL byte.arg      IS (desc \ 10) = 1:
          VAL raw.argument  IS [arg1, arg2][arg.no - 1]:
          VAL argument      IS raw.argument + (INT s.goto[i]):
          --}}}
          SEQ
            --{{{  set up command
            IF
              byte.arg
                SEQ
                  command[len] := BYTE argument
                  len := len + 1
              TRUE
                VAL zero IS INT '0':
                SEQ
                  IF
                    (argument / 10) > 0
                      SEQ
                        command[len]   := BYTE ((argument/10) + zero)
                        len := len + 1
                    TRUE
                      SKIP
                  command[len] := BYTE ((argument\10) + zero)
                  len := len + 1
            --}}}
          
            adj := FALSE
          --}}}
        s.goto[i] = iterm.arg
          --{{{  next item is an argument
          arg := TRUE
          --}}}
        TRUE
          --{{{  no arguments in sight
          SEQ
            command[len] := s.goto[i]
            len := len + 1
          --}}}
:
--}}}
--{{{  screen goto xy
PROC screen.goto.xy (CHAN OF SP fs, ts, VAL INT col, row)
  [SIZE s.goto]BYTE command:
  INT len:
  SEQ
    interpret.iterm.2.arg (col, row, command, len)
    so.write.string (fs, ts, [command FROM 0 FOR len])
:
--}}}
--{{{  screen goto
PROC screen.goto (CHAN OF SP fs, ts, VAL INT line, col, VAL BOOL hex)

  VAL screen.line IS line + header.lines:
  INT screen.column:
  SEQ
    IF
      hex
        screen.column := hex.start + (col * col.width)
      TRUE
        screen.column := ascii.start + col
    screen.goto.xy (fs, ts, screen.column, screen.line)
:
--}}}
--{{{  screen goto address
PROC screen.goto.address (CHAN OF SP fs, ts, VAL INT line)
  VAL screen.column IS address.start:
  VAL screen.line   IS line + header.lines:
  screen.goto.xy (fs, ts, screen.column, screen.line)
:
--}}}
--{{{  screen clear
PROC screen.clear(CHAN OF SP fs, ts)
  so.write.string(fs, ts, s.cls)
:
--}}}
--{{{  clear screen
PROC Clear.Screen(CHAN OF SP fs, ts)
  SEQ
    screen.clear(fs, ts)
:
--}}}
--{{{  screen clear eos
PROC screen.clear.eos (CHAN OF SP fs, ts)
  so.write.string(fs, ts, s.clr.eos)
:
--}}}
--{{{  screen clear eol
PROC screen.clear.eol (CHAN OF SP fs, ts)
  so.write.string(fs, ts, s.clr.eol)
:
--}}}
--{{{  Centred.Text
PROC Centred.Text(VAL []BYTE Text, []BYTE Centred.Text)
  VAL INT Screen.Width IS SIZE Centred.Text:
  VAL INT Middle.Of.Screen IS Screen.Width / 2:
  VAL INT Length IS SIZE Text:
  VAL INT Middle IS Length / 2:
  VAL INT Start  IS Middle.Of.Screen - (Middle):
  SEQ
    SEQ i = 0 FOR Screen.Width
      Centred.Text[i] := ' '
    [Centred.Text FROM Start FOR Length] := Text
:
--}}}
--{{{  initBYTEvec
PROC initBYTEvec ( [] BYTE vec,
                   VAL BYTE pattern,
                   VAL INT bytes)     -- Must be a power of 2
  INT dest, transfer :
  SEQ
    transfer := 1
    dest := transfer
    vec[0] := pattern
    WHILE dest < bytes
      SEQ
        IF
          ((dest + transfer) < bytes)
            SEQ
              [vec FROM dest FOR transfer] := [vec FROM 0 FOR transfer]
              dest := dest + transfer
              transfer := transfer + transfer
          TRUE
            VAL INT remainder IS (bytes - dest):
            SEQ
              [vec FROM dest FOR remainder] := [vec FROM 0 FOR remainder]
              dest := dest + remainder
              transfer := transfer + remainder

:
--}}}
--{{{  Blank.Line
PROC Blank.Line(CHAN OF SP fs, ts, VAL INT Line.Count)
  SEQ
    SEQ i = 0 FOR Line.Count
      so.write.nl(fs, ts)
:
--}}}
--{{{  Display.Line
--{{{  Verbos Form
PROC Display.Line(CHAN OF SP fs, ts, VAL []BYTE Line)
  [80]BYTE Display.Line:
  SEQ
    Centred.Text(Line, Display.Line)
    so.write.string(fs, ts, Display.Line)
:
--}}}
--{{{  Short Form
PROC dl(CHAN OF SP fs, ts, VAL []BYTE Line)
  SEQ
    Display.Line(fs, ts, Line)
:
--}}}
--}}}
--{{{  Display.Under.Scored.Line
PROC Display.Under.Scored.Line(CHAN OF SP fs, ts,
                               VAL []BYTE Line,
                               VAL BYTE   Under.Score)
  [80]BYTE Display.Line:
  [80]BYTE Under.Scored.Line:
  SEQ
    Centred.Text(Line, Display.Line)
    so.write.string(fs, ts, Display.Line)
    SEQ i = 0 FOR SIZE Line
      Under.Scored.Line[i] := Under.Score
    []BYTE temp RETYPES [Under.Scored.Line FROM 0 FOR (SIZE Line)]:
    Centred.Text(temp, Display.Line)
    so.write.string(fs, ts, Display.Line)
:
--}}}
--{{{  Display Options
PROC Display.Options(CHAN OF SP fs, ts,
                     VAL []BYTE Header,
                     VAL []BYTE Title,
                     VAL [][]BYTE Options,
                     VAL []BYTE Footer,
                     INT Selected.Option)

  VAL INT Option.Count IS SIZE Options:
  SEQ
    Clear.Screen(fs, ts)
    Display.Line(fs, ts, Header)
    so.write.nl(fs, ts)
    Display.Line(fs, ts, Title)
    so.write.nl(fs, ts)
    --{{{  Display Options
    SEQ Option = 0 FOR SIZE Options
      SEQ
        so.write.int(fs, ts, Option, 5)
        so.write.string(fs, ts, " : ")
        so.write.string.nl(fs, ts, Options[Option])
        IF
          Option = 0
            so.write.nl(fs, ts)
          TRUE
            SKIP
    --}}}
    so.write.nl(fs, ts)
    screen.goto.xy (fs, ts, 1, 21)
    Display.Line(fs, ts, Footer)
    --{{{  Get User Option
    BYTE Key, Result:
    SEQ
      Selected.Option := -1
      so.write.string(fs, ts, "  > ")
      WHILE ((Selected.Option < 0) OR (Selected.Option > (Option.Count-1)))
        SEQ
          so.getkey(fs, ts, Key, Result)
          IF
            Result = 0 (BYTE)
              Selected.Option := (INT Key) - 48
            TRUE
              Selected.Option := -1
    --}}}
    Clear.Screen(fs, ts)
:
--}}}
--{{{  Press Any Key to Continue
PROC Press.Any.Key.To.Continue(CHAN OF SP fs, ts)
  BYTE Key, Result:
  SEQ
    Display.Line(fs, ts, "Press any key to continue")
    so.getkey(fs, ts, Key, Result)
:
--}}}
--{{{  Activity Monitor
PROC Activity.Monitor(CHAN OF SP fs, ts,
                      INT Compass.Direction,
                      VAL INT Delay)
  SEQ
    --{{{  Display Acitivity
    CASE Compass.Direction
      0
        so.write.char(fs, ts, '|')
      1
        so.write.char(fs, ts, '/')
      2
        so.write.char(fs, ts, '-')
      3
        so.write.char(fs, ts, '\')
      4
        so.write.char(fs, ts, '|')
      5
        so.write.char(fs, ts, '/')
      6
        so.write.char(fs, ts, '-')
      7
        so.write.char(fs, ts, '\')
      ELSE
        so.write.char(fs, ts, '?')
    TIMER Clock:
    INT   Time, Delay.Time:
    SEQ
      Clock ? Time
      Delay.Time := Time PLUS Delay
      Clock ? AFTER (Delay.Time)
    so.write.char(fs, ts, '*c')
    Compass.Direction := ((Compass.Direction + 1) /\ 7)
    --}}}
:
--}}}
--{{{  Prepare Status Message
PROC Prepare.Status.Message(VAL INT16 Execution.Status,
                            []BYTE Status.Message)
  #USE "convert.lib"
  INT len:
  SEQ
    --{{{  Clear Status Message
    SEQ I = 0 FOR SIZE Status.Message
      Status.Message[I] := ' '
    --}}}
    len := 4
    [Status.Message FROM 0 FOR 20] := "Execution Status : #"
    [4]BYTE E.S RETYPES [Status.Message FROM 20 FOR 4]:
    HEX16TOSTRING(len, E.S, Execution.Status)
    [Status.Message FROM 24 FOR 3] := " : "
    CASE Execution.Status
      --{{{  Display Appropriate Status
      SCSI.E.Good
        [Status.Message FROM 27 FOR 4]  := "Good"
      SCSI.E.Bad.SCSI.Status
        [Status.Message FROM 27 FOR 15] := "Bad.SCSI.Status"
      SCSI.E.Command.Not.Complete
        [Status.Message FROM 27 FOR 20] := "Command.Not.Complete"
      SCSI.E.Incorrect.IO.Process.Number
        [Status.Message FROM 27 FOR 27] := "Incorrect.IO.Process.Number"
      SCSI.E.SCSI.Bus.Parity.Error
        [Status.Message FROM 27 FOR 21] := "SCSI.Bus.Parity.Error"
      SCSI.E.Data.In.Failure
        [Status.Message FROM 27 FOR 15] := "Data.In.Failure"
      SCSI.E.Bad.Data.In.Returned.Packet.Size
        [Status.Message FROM 27 FOR 32] := "Bad.Data.In.Returned.Packet.Size"
      SCSI.E.Data.Out.Failure
        [Status.Message FROM 27 FOR 16] := "Data.Out.Failure"
      SCSI.E.Bad.Data.Out.Returned.Packet.Size
        [Status.Message FROM 27 FOR 33] := "Bad.Data.Out.Returned.Packet.Size"
      SCSI.E.Data.In.Time.Out
        [Status.Message FROM 27 FOR 16] := "Data.In.Time.Out"
      SCSI.E.Data.Out.Time.Out
        [Status.Message FROM 27 FOR 17] := "Data.Out.Time.Out"
      SCSI.E.Command.Time.Out
        [Status.Message FROM 27 FOR 16] := "Command.Time.Out"
      SCSI.E.Status.Time.Out
        [Status.Message FROM 27 FOR 15] := "Status.Time.Out"
      SCSI.E.Controller.Reset.Time.Out
        [Status.Message FROM 27 FOR 25] := "Controller.Reset.Time.Out"
      SCSI.E.Bus.Reset.Time.Out
        [Status.Message FROM 27 FOR 18] := "Bus.Reset.Time.Out"
      SCSI.E.Reselected
        [Status.Message FROM 27 FOR 10] := "Reselected"
      SCSI.E.Function.Not.Complete
        [Status.Message FROM 27 FOR 21] := "Function.Not.Complete"
      SCSI.E.Disconnected
        [Status.Message FROM 27 FOR 12] := "Disconnected"
      SCSI.E.Not.Bus.Service
        [Status.Message FROM 27 FOR 15] := "Not.Bus.Service"
      SCSI.E.Sequence.Not.Complete
        [Status.Message FROM 27 FOR 21] := "Sequence.Not.Complete"
      SCSI.E.Premature.Phase.Change
        [Status.Message FROM 27 FOR 22] := "Premature.Phase.Change"
      SCSI.E.Target.Did.Not.Assert.ATN
        [Status.Message FROM 27 FOR 25] := "Target.Did.Not.Assert.ATN"
      SCSI.E.Target.Did.Not.Assert.Message.Out
        [Status.Message FROM 27 FOR 33] := "Target.Did.Not.Assert.Message.Out"
      SCSI.E.Selection.Time.Out
        [Status.Message FROM 27 FOR 18] := "Selection.Time.Out"
      SCSI.E.Undocumented.Error
        [Status.Message FROM 27 FOR 18] := "Undocumented.Error"
      SCSI.E.Data.In.Abort
        [Status.Message FROM 27 FOR 13] := "Data.In.Abort"
      SCSI.E.Data.Out.Abort
        [Status.Message FROM 27 FOR 14] := "Data.Out.Abort"
      SCSI.E.Unexpected.Phase.Change
        [Status.Message FROM 27 FOR 23] := "Unexpected.Phase.Change"
      SCSI.E.Failed.Self.Test
        [Status.Message FROM 27 FOR 16] := "Failed.Self.Test"
      SCSI.E.Interrupt.Time.Out
        [Status.Message FROM 27 FOR 18] := "Interrupt.Time.Out"
      SCSI.E.Software.Error
        [Status.Message FROM 27 FOR 14] := "Software.Error"
      SCSI.E.Not.Implemented
        [Status.Message FROM 27 FOR 15] := "Not.Implemented"
      ELSE
        [Status.Message FROM 27 FOR 29] := "Unrecognised Execution Status"
      --}}}
:
--}}}
--{{{  Display Execution Status Only
PROC Display.Execution.Status( CHAN OF SP fs, ts, VAL INT16 Execution.Status)
  SEQ
    IF
      ((INT Execution.Status) <> (INT SCSI.E.Good))
        SEQ
          --{{{  Display Status
          so.write.string(fs, ts, " Error : Execution.Status = ")
          CASE Execution.Status
            --{{{  Display Appropriate Message
            SCSI.E.Good
              so.write.string.nl(fs, ts, "Good  ")
            SCSI.E.Bad.SCSI.Status
              so.write.string.nl(fs, ts, "Bad.SCSI.Status")
            SCSI.E.Command.Not.Complete
              so.write.string.nl(fs, ts, "Command.Not.Complete ")
            SCSI.E.Incorrect.IO.Process.Number
              so.write.string.nl(fs, ts, "Incorrect.IO.Process.Number")
            SCSI.E.SCSI.Bus.Parity.Error
              so.write.string.nl(fs, ts, "SCSI.Bus.Parity.Error")
            SCSI.E.Data.In.Failure
              so.write.string.nl(fs, ts, "Data.In.Failure")
            SCSI.E.Bad.Data.In.Returned.Packet.Size
              so.write.string.nl(fs, ts, "Bad.Data.In.Returned.Packet.Size ")
            SCSI.E.Data.Out.Failure
              so.write.string.nl(fs, ts, "Data.Out.Failure  ")
            SCSI.E.Bad.Data.Out.Returned.Packet.Size
              so.write.string.nl(fs, ts, "Bad.Data.Out.Returned.Packet.Size")
            SCSI.E.Data.In.Time.Out
              so.write.string.nl(fs, ts, "Data.In.Time.Out  ")
            SCSI.E.Data.Out.Time.Out
              so.write.string.nl(fs, ts, "Data.Out.Time.Out ")
            SCSI.E.Command.Time.Out
              so.write.string.nl(fs, ts, "Command.Time.Out  ")
            SCSI.E.Status.Time.Out
              so.write.string.nl(fs, ts, "Status.Time.Out")
            SCSI.E.Controller.Reset.Time.Out
              so.write.string.nl(fs, ts, "Controller.Reset.Time.Out  ")
            SCSI.E.Bus.Reset.Time.Out
              so.write.string.nl(fs, ts, "Bus.Reset.Time.Out")
            SCSI.E.Reselected
              so.write.string.nl(fs, ts, "Reselected  ")
            SCSI.E.Function.Not.Complete
              so.write.string.nl(fs, ts, "Function.Not.Complete")
            SCSI.E.Disconnected
              so.write.string.nl(fs, ts, "Disconnected")
            SCSI.E.Not.Bus.Service
              so.write.string.nl(fs, ts, "Not.Bus.Service")
            SCSI.E.Sequence.Not.Complete
              so.write.string.nl(fs, ts, "Sequence.Not.Complete")
            SCSI.E.Premature.Phase.Change
              so.write.string.nl(fs, ts, "Premature.Phase.Change  ")
            SCSI.E.Target.Did.Not.Assert.ATN
              so.write.string.nl(fs, ts, "Target.Did.Not.Assert.ATN  ")
            SCSI.E.Target.Did.Not.Assert.Message.Out
              so.write.string.nl(fs, ts, "Target.Did.Not.Assert.Message.Out")
            SCSI.E.Selection.Time.Out
              so.write.string.nl(fs, ts, "Selection.Time.Out")
            SCSI.E.Undocumented.Error
              so.write.string.nl(fs, ts, "Undocumented.Error")
            SCSI.E.Data.In.Abort
              so.write.string.nl(fs, ts, "Data.In.Abort  ")
            SCSI.E.Data.Out.Abort
              so.write.string.nl(fs, ts, "Data.Out.Abort ")
            SCSI.E.Unexpected.Phase.Change
              so.write.string.nl(fs, ts, "Unexpected.Phase.Change ")
            SCSI.E.Failed.Self.Test
              so.write.string.nl(fs, ts, "Failed.Self.Test  ")
            SCSI.E.Software.Error
              so.write.string.nl(fs, ts, "Software.Error ")
            SCSI.E.Not.Implemented
              so.write.string.nl(fs, ts, "Not.Implemented")
            ELSE
              SEQ
                so.write.string(fs, ts, "Unrecognised Exection Status")
                so.write.hex.int(fs, ts, (INT Execution.Status), 4)
            --}}}
          Press.Any.Key.To.Continue(fs, ts)
          --}}}
      TRUE
        SKIP
:
--}}}
--{{{  Display Status
PROC Display.SCSI.Status(CHAN OF SP fs, ts,
                         []BYTE Message,
                         BYTE Msg.Length,
                         BYTE SCSI.Status,
                         INT16 Execution.Status)
  SEQ
    IF
      ((INT Execution.Status) <> (INT SCSI.E.Good))
        SEQ
          --{{{  Display Status
          so.write.string( fs, ts, "Status = ")
          so.write.hex.int( fs, ts, INT SCSI.Status, 2)
          IF
            Msg.Length > Zero.B
              SEQ
                so.write.string (fs, ts, " : Message : ")
                SEQ i = 0 FOR INT Msg.Length
                  so.write.hex.int ( fs, ts, INT Message[i], 2)
            TRUE
              SKIP
          
          Prepare.Status.Message(Execution.Status, Status.Message)
          Display.Line(fs, ts, Status.Message)
          --}}}
      TRUE
        SKIP
:
--}}}
--{{{  Display Target and Lun
PROC Display.Target.ID.and.LUN(CHAN OF SP fs, ts, BYTE Target.ID, BYTE LUN)
  SEQ
    --{{{  Target ID
    so.write.string(fs, ts, "Target ID = ")
    so.write.int(fs, ts, INT Target.ID, 1)
    so.write.nl(fs, ts)
    --}}}
    --{{{  LUN
    so.write.string(fs, ts, "LUN = ")
    so.write.int(fs, ts, INT LUN, 1)
    so.write.nl(fs, ts)
    --}}}
:
--}}}
--{{{  Display Current Settings
PROC Display.Current.Settings(CHAN OF SP fs, ts)
  SEQ
    Display.Under.Scored.Line(fs, ts, "Current Settings", '=')
    so.write.nl(fs, ts)
    --{{{  Initiator ID
    so.write.string(fs, ts, "Initiator ID = ")
    so.write.int(fs, ts, INT Initiator.ID, 1)
    so.write.nl(fs, ts)
    --}}}
    --{{{  Target and LUN
    Display.Target.ID.and.LUN(fs, ts, Target.ID, LUN)
    --}}}
    --{{{  ATN
    CASE INT ATN
      0
        so.write.string.nl(fs, ts, "Select with ATN is Disabled")
      1
        so.write.string.nl(fs, ts, "Select with ATN is Enabled")
      ELSE
        so.write.string.nl(fs, ts, "Select with ATN is Undefined")
    --}}}
    --{{{  Parity Info
    --{{{  Parity Checking
    CASE Parity.Checking
      Enable.Parity.Checking
        so.write.string.nl(fs, ts, "Parity Checking is Enabled")
      Disable.Parity.Checking
        so.write.string.nl(fs, ts, "Parity Checking is Disabled")
      ELSE
        so.write.string.nl(fs, ts, "Parity Checking is Undefined")
    --}}}
    --{{{  Parity Generation
    CASE Parity.Generation
      Enable.Parity.Generation
        so.write.string.nl(fs, ts, "Parity Generation is Enabled")
      Disable.Parity.Generation
        so.write.string.nl(fs, ts, "Parity Generation is Disabled")
      ELSE
        so.write.string.nl(fs, ts, "Parity Generation is Undefined")
    --}}}
    --}}}
    --{{{  Data Transfer Mode
    so.write.string(fs, ts, "Data Transfer Mode : ")
    CASE INT Data.Transfer.Mode
      -2
        so.write.string.nl(fs, ts, "Non DMA Mode - with a delay of 1 uSecond after each byte sent")
      -1
        so.write.string.nl(fs, ts, "Non DMA Mode")
      0
        so.write.string.nl(fs, ts, "Non supported transfer mode")
      1
        so.write.string.nl(fs, ts, "Fast (pseudo) DMA Mode")
      2
        so.write.string.nl(fs, ts, "Slow (pseudo) DMA Mode")
      3
        so.write.string.nl(fs, ts, "Slow (pseudo) DMA Mode - with a delay of 1 uSecond after every 2 bytes sent")
      ELSE
        IF
          ((INT Data.Transfer.Mode) > 0)
            SEQ
              --{{{
              so.write.string(fs, ts, "Slow (pseudo) DMA Mode - with a delay of ")
              so.write.int(fs, ts, ((INT Data.Transfer.Mode) - 2), 5)
              so.write.string.nl(fs, ts, " uSeconds after every 2 bytes sent")
              --}}}
          TRUE
            SEQ
              --{{{
              so.write.string(fs, ts, "Non DMA Mode - with a delay of ")
              so.write.int(fs, ts, (((-1) * (INT Data.Transfer.Mode)) - 1), 5)
              so.write.string.nl(fs, ts, " uSeconds after every byte sent")
              --}}}
    
    --}}}
    --{{{  Disconnection Mode
    CASE INT Disconnect.Mode
      0
        so.write.string.nl(fs, ts, "Disconnection is Enabled")
      1
        so.write.string.nl(fs, ts, "Disconnection is Disabled")
      ELSE
        so.write.string.nl(fs, ts, "Disconnection is Undefined")
    --}}}
    Press.Any.Key.To.Continue(fs, ts)
:
--}}}
--{{{  Define Test Buffer
PROC Define.Test.Buffer( []BYTE Buffer, VAL INT Size)
  INT i:
  SEQ
    i := 0
    SEQ j = 0 FOR Size
      INT Lower.Byte:
      SEQ
        Lower.Byte := (j /\ #FF)
        Buffer[j] := BYTE (Lower.Byte)
:
--}}}
--{{{  Compare Test Buffer
PROC Compare.Byte.Buffers( VAL []BYTE Buffer, VAL []BYTE Compare, INT Failures, VAL INT Size)
  VAL []INT I.Buff RETYPES Buffer:
  VAL []INT C.Buff RETYPES Compare:
  VAL INT I.Size IS (Size / Bytes.Per.INT):
  SEQ
    SEQ j = 0 FOR I.Size
      IF
        I.Buff[j] <> C.Buff[(j /\ 63)]
          --{{{  increment byte failure count
          VAL []BYTE I.Bytes RETYPES I.Buff[j]:
          VAL []BYTE C.Bytes RETYPES C.Buff[(j /\ 63)]:
          SEQ i = 0 FOR Bytes.Per.INT
            SEQ
              IF
                I.Bytes[i] <> C.Bytes[i]
                  Failures := Failures + 1
                TRUE
                  SKIP
          --}}}
        TRUE
          SKIP
:
--}}}
--{{{  Define Data Blocks
PROC Define.Data.Blocks([]BYTE  Data.Blocks,
                        []BYTE  Compare.Buff,
                        INT     Error.Count,
                        VAL INT Transfer.Size)
  SEQ
    VAL INT C.Size IS SIZE Compare.Buff:
    VAL INT Count IS (Number.of.Blocks * (Block.Size.INT / C.Size)):
    SEQ
      Define.Test.Buffer( Compare.Buff, C.Size)
      SEQ i = 0 FOR Count
        VAL INT Index IS (i * C.Size):
        SEQ
          [Data.Blocks FROM Index FOR C.Size] := [Compare.Buff FROM 0 FOR C.Size]
    Compare.Byte.Buffers(Data.Blocks, Compare.Buff, Error.Count, Transfer.Size)
:
--}}}
