--{{{  Not Implemented
PROC Not.Implemented(CHAN OF SP fs, ts)
  SEQ
    Clear.Screen(fs, ts)
    SEQ I = 0 FOR 10
      so.write.nl(fs, ts)
    Display.Line(fs, ts, "Not Implemented")
    so.write.nl(fs, ts)
    Press.Any.Key.To.Continue(fs, ts)
:
--}}}
--{{{  Set Identify Message
PROC Set.Identify.Message()
  SEQ
    IF
      Disconnect.Mode = Disconnection.Disabled
        Msg.Length := 0 (BYTE)
      Disconnect.Mode = Disconnection.Enabled
        SEQ
          Msg.Length := 1 (BYTE)
          Message[0] := BYTE (#C0 \/ (INT LUN))
      TRUE
        Not.Implemented(fs, ts)
:
--}}}
--{{{  Display Request Sense
PROC Display.Request.Sense.Data( CHAN OF SP fs, ts, []BYTE Rs.Buffer)
  SEQ
    --{{{  Display
    so.write.nl(fs, ts)
    so.write.nl(fs, ts)
    Display.Under.Scored.Line(fs, ts, "Request Sense Data", '=')
    so.write.nl(fs, ts)
    so.write.nl(fs, ts)
    so.write.string(fs, ts, "Error Code             : ")
    so.write.hex.int(fs, ts, ((INT Rs.Buffer[0]) /\
                          Request.Sense.6.Error.Code), 2)
    so.write.nl(fs, ts)
    so.write.string(fs, ts, "Valid                  : ")
    so.write.hex.int(fs, ts, (ROTATERIGHT (INT Rs.Buffer[0], 7) /\
                          Request.Sense.6.Valid), 1)
    so.write.nl(fs, ts)
    so.write.string(fs, ts, "Segment Number         : ")
    so.write.hex.int(fs, ts, INT Rs.Buffer[1], 2)
    so.write.nl(fs, ts)
    so.write.string(fs, ts, "Sense Key              : ")
    so.write.hex.int(fs, ts, ((INT Rs.Buffer[2]) /\
                          Request.Sense.6.Sense.Key), 1)
    so.write.nl(fs, ts)
    IF
      (Request.Sense.Allocation.Length > 18)
        --{{{  Display Remainder of Sense Data
        INT Col.Count:
        SEQ
          so.write.string(fs, ts, "Extra Sense Data : ")
          Col.Count := 0
          SEQ Row = 19 FOR (Request.Sense.Allocation.Length - 18)
            SEQ
              so.write.hex.int(fs, ts, (INT Rs.Buffer[Row]), 2)
              IF
                (Col.Count > 25)
                  SEQ
                    so.write.nl(fs, ts)
                    Col.Count := 0
                TRUE
                  Col.Count := Col.Count + 1
          so.write.nl(fs, ts)
        --}}}
      TRUE
        SKIP
    --}}}
    --{{{  Clear
    SEQ i = 0 FOR SIZE Rs.Buffer
      Rs.Buffer[i] := Zero.B
    --}}}
:
--}}}
--{{{  Data Transfer Mode
PROC Data.Transfer.Mode.Selection(CHAN OF SP fs, ts,
                                  CHAN OF TO.SCSI tscsi,
                                  CHAN OF FROM.SCSI fscsi)
  BOOL Going:
  INT  reply:
  SEQ
    Going := TRUE
    Execution.Status := SCSI.E.Good
    WHILE Going
      SEQ
        --{{{  Prompt User
        Display.Options(fs, ts,
                        Main.Title,
                        "Data Transfer Mode Selection",
                        ["Exit                         ",
                         "Non DMA Mode - with no delay ",
                         "Non DMA Mode - with delay    ",
                         "Fast DMA Mode                ",
                         "Slow DMA Mode - with no delay",
                         "Slow DMA Mode - with delay   "],
                         Status.Message,
                         reply)
        --}}}
        --{{{  Do User request
        CASE reply
          0
            Going := FALSE
          1
            Data.Transfer.Mode := -2 (INT16)
          2
            Data.Transfer.Mode := -1 (INT16)
          3
            Data.Transfer.Mode := SCSI.Fast.DMA.Mode
          4
            Data.Transfer.Mode := SCSI.Slow.DMA.Mode
          5
            Data.Transfer.Mode := SCSI.Very.Slow.DMA.Mode
          ELSE
            Not.Implemented(fs, ts)
        
        SCSI.Define.Data.Transfer.Mode ( tscsi,
                                         fscsi,
                                         Data.Transfer.Mode,
                                         Execution.Status)
        
        Prepare.Status.Message(Execution.Status, Status.Message)
        --}}}
:

--}}}
