PROC Sequential.Access.Device.Types(CHAN OF SP fs, ts,
                                    CHAN OF TO.SCSI tscsi,
                                    CHAN OF FROM.SCSI fscsi)
  BOOL Going:
  INT  reply:
  SEQ
    Going := TRUE
    WHILE Going
      SEQ
        --{{{  Prompt User
        Display.Options(fs, ts,
                        Main.Title,
                        "Sequential Access Device Types (Chapter 9)",
                        ["Exit           ",
                         "Define Bus ID  ",
                         "Request Sense  ",
                         "Read           ",
                         "Write          ",
                         "Rewind         ",
                         "Load           ",
                         "Unload         ",
                         "Read Test      ",
                         "Write Test     "],
                         Status.Message,
                         reply)
        --}}}  
        --{{{  Do User request
        CASE reply
          0
            Going := FALSE
          1
            --{{{  Prompt operator for initiator and target SCSI device ID's
            BOOL First.Time:
            SEQ
              First.Time := TRUE
              Initiator.ID := 7 (BYTE)
              Target.ID := 7 (BYTE)
              WHILE (Initiator.ID = Target.ID)
                SEQ
                  IF
                    NOT First.Time
                      --{{{  Warning Message
                      so.write.string.nl(fs, ts, "Initiator ID and Target ID must be different.")
                      --}}}  
                    TRUE
                      First.Time := FALSE
                  --{{{  Prompt Operator for Initiator ID
                  INT reply:
                  SEQ
                    Quit := TRUE
                    so.ask(fs, ts,
                           "Which Initiator ID do you wish to set IMS B422 as > ",
                           "01234567",
                           TRUE,
                           TRUE,
                           reply)
                    Initiator.ID := BYTE reply
                    so.write.nl(fs, ts)
                    so.write.nl(fs, ts)
                  --}}}  
                  --{{{  Prompt Operator for Target ID
                  INT reply:
                  SEQ
                    Quit := TRUE
                    so.ask(fs, ts,
                           "Which Target ID do you wish IMS B422 to talk to   > ",
                           "01234567",
                           TRUE,
                           TRUE,
                           reply)
                    Target.ID := BYTE reply
                    so.write.nl(fs, ts)
                    so.write.nl(fs, ts)
                  --}}}  
              --{{{  Make IMS B422 an Initiator
              so.write.string.nl(fs, ts, "Make B422 an Initiator")
              Enable.Initiator.Mode( tscsi,
                                     fscsi,
                                     BYTE Initiator.ID,
                                     Execution.Status)
              --}}}  
              Prepare.Status.Message(Execution.Status, Status.Message)
            --}}}  
          2
            SEQ
              --{{{  Request Sense
              Request.Sense(fs, ts, tscsi, fscsi)
              --}}}  
          3
            SEQ
              --{{{  Read
              BOOL error:
              INT Block.Size, Block.Count:
              SEQ
                so.write.string.nl(fs, ts, "Read a Block")
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "How Many Blocks ?")
                    so.read.echo.int(fs, ts, Block.Count, error)
                    so.write.nl(fs, ts)
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "Block Size ?")
                    so.read.echo.int(fs, ts, Block.Size, error)
                    so.write.nl(fs, ts)
                Set.Identify.Message()
                initBYTEvec(Data.Block, Zero.B, Block.Count * Block.Size)
                SCSI.SA.Read.6( tscsi,
                                fscsi,
                                Target.ID,
                                LUN,
                                1 (BYTE),
                                1 (BYTE),
                                INT32 Block.Count,
                                INT32 Block.Size,
                                Non.Linked.Command,
                                Data.Block,
                                Msg.Length,
                                Message,
                                SCSI.Status,
                                Execution.Status)
                Prepare.Status.Message(Execution.Status, Status.Message)
                IF
                  (Execution.Status <> SCSI.E.Good)
                    Hex.Editor( fs, ts, 0, Data.Block, Status.Message)
                  TRUE
                    Hex.Editor( fs, ts, 0, Data.Block, "Data Read From Disk")
              --}}}  
          4
            SEQ
              --{{{  Write
              BOOL error:
              INT Block.Size, Block.Count:
              SEQ
                so.write.string.nl(fs, ts, "Write a Block")
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "How Many Blocks ?")
                    so.read.echo.int(fs, ts, Block.Count, error)
                    so.write.nl(fs, ts)
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "Block Size ?")
                    so.read.echo.int(fs, ts, Block.Size, error)
                    so.write.nl(fs, ts)
                Define.Test.Buffer(Data.Block, Block.Count * Block.Size)
                Hex.Editor( fs, ts, 0, Data.Block, "Edit Data to be Written")
                Set.Identify.Message()
                SCSI.SA.Write.6( tscsi,
                                 fscsi,
                                 Target.ID,
                                 LUN,
                                 1 (BYTE),
                                 INT32 Block.Count,
                                 INT32 Block.Size,
                                 Non.Linked.Command,
                                 Data.Block,
                                 Msg.Length,
                                 Message,
                                 SCSI.Status,
                                 Execution.Status)
                Prepare.Status.Message(Execution.Status, Status.Message)
              --}}}  
          5
            SEQ
              --{{{  Rewind
              so.write.string.nl(fs, ts, "SCSI.Rewind.6")
              SEQ
                Set.Identify.Message()
                SCSI.SA.Rewind.6 ( tscsi,
                                   fscsi,
                                   Target.ID,
                                   LUN,
                                   0 (BYTE),
                                   Non.Linked.Command,
                                   Msg.Length,
                                   Message,
                                   SCSI.Status,
                                   Execution.Status)
                Prepare.Status.Message(Execution.Status, Status.Message)
              --}}}  
          6
            SEQ
              --{{{  Load
              --so.write.string.nl(fs, ts, "Not Implemented")
              so.write.string.nl(fs, ts, "SCSI.Load.6")
              
              Set.Identify.Message()
              SCSI.SA.Load.Unload.6 ( tscsi,
                                      fscsi,
                                      Target.ID,
                                      LUN,
                                      0 (BYTE),
                                      Zero.B, --Re Ten not implemented
                                      Zero.B,
                                      1 (BYTE), -- Load
                                      Non.Linked.Command,
                                      Msg.Length,
                                      Message,
                                      SCSI.Status,
                                      Execution.Status)
              
              Prepare.Status.Message(Execution.Status, Status.Message)
              --}}}  
          7
            SEQ
              --{{{  UnLoad
              --so.write.string.nl(fs, ts, "Not Implemented")
              so.write.string.nl(fs, ts, "SCSI.Unload.6")
              
              Set.Identify.Message()
              SCSI.SA.Load.Unload.6 ( tscsi,
                                      fscsi,
                                      Target.ID,
                                      LUN,
                                      0 (BYTE),
                                      Zero.B, --Re Ten not implemented
                                      Zero.B, -- UnLoad
                                      Zero.B,
                                      Non.Linked.Command,
                                      Msg.Length,
                                      Message,
                                      SCSI.Status,
                                      Execution.Status)
              
              Prepare.Status.Message(Execution.Status, Status.Message)
              --}}}  
          8
            --{{{  Write Test
            INT Block.Size, Block.Count:
            INT Group.Count, Group.Size:
            INT I:
            SEQ
              Group.Size := 2457600
              --{{{  Prompt user
              --{{{  Block Size
              BOOL error:
              SEQ
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "Block Size ?")
                    so.read.echo.int(fs, ts, Block.Size, error)
                    so.write.nl(fs, ts)
              --}}}  
              --{{{  Number of Blocks
              BOOL error:
              SEQ
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "Number of Blocks per group ?")
                    so.read.echo.int(fs, ts, Block.Count, error)
                    so.write.nl(fs, ts)
              --}}}  
              --}}}  
              Define.Test.Buffer(Data.Block, Block.Count * Block.Size)
              --{{{  
              BOOL error:
              SEQ
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "How Many Groups of 2.4 MBytes ?")
                    so.read.echo.int(fs, ts, Group.Count, error)
                    so.write.nl(fs, ts)
                error := TRUE
              --}}}  
              I := 0
              WHILE (I < Group.Count)
                --{{{  Write
                TIMER Clock:
                INT Before, After, Time.Taken:
                SEQ
                  INT X RETYPES [Data.Block FROM 0 FOR 4]:
                  SEQ
                    X := ((2400*I)+1)
                  so.write.string(fs, ts, "Writing Relative Block Number : ")
                  so.write.int(fs, ts, (I * (Group.Count * Group.Size)), 10)
                  Clock ? Before
                  PRI PAR
                    INT J:
                    SEQ
                      J := 0
                      WHILE (J < Group.Size)
                        --{{{  Write
                        SEQ
                          Set.Identify.Message()
                          SCSI.SA.Write.6( tscsi,
                                           fscsi,
                                           Target.ID,
                                           LUN,
                                           1 (BYTE),
                                           INT32 Block.Count,
                                           INT32 Block.Size,
                                           Non.Linked.Command,
                                           Data.Block,
                                           Msg.Length,
                                           Message,
                                           SCSI.Status,
                                           Execution.Status)
                          IF
                            (Execution.Status = SCSI.E.Good)
                              J := J + 1
                            TRUE
                              J := Group.Size
                        --}}}  
                    SKIP
                  Clock ? After
                  Time.Taken := After MINUS Before
                  IF
                    (Execution.Status = SCSI.E.Good)
                      BYTE key, result:
                      SEQ
                        I := I + 1
                        --{{{  Display Write Time
                        so.write.string(fs, ts, " at : ")
                        so.write.real32(fs, ts,((2457600.0 (REAL32) /(REAL32 ROUND Time.Taken)) / 64.0 (REAL32)), 10, 3)
                        so.write.string(fs, ts, " MB/Sec ")
                        --}}}  
                        so.write.string(fs, ts, " *C")
                        so.pollkey(fs, ts, key, result)
                        IF
                          result = spr.ok
                            SEQ
                              Prepare.Status.Message(Execution.Status, Status.Message)
                              I := Group.Count
                          TRUE
                            SKIP
                    TRUE
                      SEQ
                        Prepare.Status.Message(Execution.Status, Status.Message)
                        I := Group.Count
                --}}}  
              so.write.nl(fs, ts)
              Press.Any.Key.To.Continue(fs, ts)
            --}}}  
          9
            --{{{  Read Test
            INT Block.Size, Block.Count:
            INT Group.Count, Group.Size:
            INT I:
            SEQ
              Group.Size := 2457600
              --{{{  Prompt user
              --{{{  Block Size
              BOOL error:
              SEQ
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "Block Size ?")
                    so.read.echo.int(fs, ts, Block.Size, error)
                    so.write.nl(fs, ts)
              --}}}  
              --{{{  Number of Blocks
              BOOL error:
              SEQ
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "Number of Blocks per group ?")
                    so.read.echo.int(fs, ts, Block.Count, error)
                    so.write.nl(fs, ts)
              --}}}  
              --}}}  
              initBYTEvec(Data.Block, Zero.B, Block.Count * Block.Size)
              --{{{  
              BOOL error:
              SEQ
                error := TRUE
                WHILE error
                  SEQ
                    so.write.string.nl(fs, ts, "How Many Groups of 2.4 MBytes ?")
                    so.read.echo.int(fs, ts, Group.Count, error)
                    so.write.nl(fs, ts)
                error := TRUE
              --}}}  
              I := 0
              WHILE (I < Group.Count)
                --{{{  Read
                TIMER Clock:
                INT Before, After, Time.Taken:
                SEQ
                  Set.Identify.Message()
                  so.write.string(fs, ts, "Reading Relative Block Number : ")
                  so.write.int(fs, ts, (I * (Group.Count * Group.Size)), 10)
                  Clock ? Before
                  PRI PAR
                    INT J:
                    SEQ
                      J := 0
                      WHILE (J < Group.Size)
                        --{{{  Read
                        SEQ
                          Set.Identify.Message()
                          SCSI.SA.Read.6( tscsi,
                                          fscsi,
                                          Target.ID,
                                          LUN,
                                          1 (BYTE),
                                          1 (BYTE),
                                          INT32 Block.Count,
                                          INT32 Block.Size,
                                          Non.Linked.Command,
                                          Data.Block,
                                          Msg.Length,
                                          Message,
                                          SCSI.Status,
                                          Execution.Status)
                          IF
                            (Execution.Status = SCSI.E.Good)
                              J := J + 1
                            TRUE
                              J := Group.Size
                        --}}}  
                    SKIP
                  Clock ? After
                  Time.Taken := After MINUS Before
                  IF
                    (Execution.Status = SCSI.E.Good)
                      BYTE key, result:
                      SEQ
                        I := I + 1
                        --{{{  Display Read Time
                        so.write.string(fs, ts, " at : ")
                        so.write.real32(fs, ts,((2457600.0 (REAL32) /(REAL32 ROUND Time.Taken)) / 64.0 (REAL32)), 10, 3)
                        so.write.string(fs, ts, " MB/Sec ")
                        --}}}  
                        so.write.string(fs, ts, " *C")
                        so.pollkey(fs, ts, key, result)
                        IF
                          result = spr.ok
                            SEQ
                              Prepare.Status.Message(Execution.Status, Status.Message)
                              I := Group.Count
                          TRUE
                            SKIP
                    TRUE
                      SEQ
                        Prepare.Status.Message(Execution.Status, Status.Message)
                        I := Group.Count
                --}}}  
              so.write.nl(fs, ts)
              Press.Any.Key.To.Continue(fs, ts)
            --}}}  
          ELSE
            so.write.string.nl(fs, ts, "Not Implemented")
        --}}}  
:
