/*{{{  Header*/
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product release SCSI Software libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 10_December_1991 */
/* */
/* File Name   : i_alldev.h */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Version     : 1.3 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : SCSI All Device types interfaces to I_ALLDEV.LIB       */
/* */
/*-------------------------------------------------------------------------- */
/* Schedule of Amendments */
/*-------------------------------------------------------------------------- */
/* 10/12/91 - PF Removed Wrappers to call occam indirectly                   */
/*-------------------------------------------------------------------------- */
/*}}}  */
#include <channel.h>
/*{{{  Build Commands*/
/*{{{  SCSI_Build_Change_Definition_10*/
#pragma IMS_translate ( SCSI_Build_Change_Definition_10 ,"SCSI.Build.Change.Definition.10")

 void      SCSI_Build_Change_Definition_10 ( const char   lun ,
                                             const char   reserved_1 ,
                                             const char   reserved_2 ,
                                             const char   save ,
                                             const char   reserved_3 ,
                                             const char   definition_parameter ,
                                             const char   reserved_4 ,
                                             const char   reserved_5 ,
                                             const char   reserved_6 ,
                                             const char   reserved_7 ,
                                             const char   parameter_data_length ,
                                             const char   control_byte ,
                                             char        *scsi_command_length ,
                                             char         scsi_command[] ,
                                             int          scsi_command_size,
                                             char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Change_Definition_10 )
/*}}}  */
/*{{{  SCSI_Build_Compare_10*/
#pragma IMS_translate ( SCSI_Build_Compare_10 ,"SCSI.Build.Compare.10")

 void SCSI_Build_Compare_10 ( const char     lun ,
                              const char     reserved_1 ,
                              const char     pad ,
                              const char     reserved_2 ,
                              const long int parameter_list_length ,
                              const char     reserved_6 ,
                              const char     reserved_7 ,
                              const char     reserved_8 ,
                              const char     control_byte ,
                              char          *scsi_command_length ,
                              char           scsi_command[] ,
                              int            scsi_command_size,
                              char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Compare_10 )
/*}}}  */
/*{{{  SCSI_Build_Copy_6*/
#pragma IMS_translate ( SCSI_Build_Copy_6 ,"SCSI.Build.Copy.6")

 void SCSI_Build_Copy_6 ( const char     lun ,
                          const char     reserved_1 ,
                          const char     pad ,
                          const long int parameter_list_length ,
                          const char     control_byte ,
                          char          *scsi_command_length ,
                          char           scsi_command[] ,
                          int            scsi_command_size,
                          char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Copy_6 )
/*}}}  */
/*{{{  SCSI_Build_Copy_And_Verify_10*/
#pragma IMS_translate( SCSI_Build_Copy_And_Verify_10 ,"SCSI.Build.Copy.And.Verify.10")

 void SCSI_Build_Copy_And_Verify_10 ( const char      lun ,
                                      const char      reserved_1 ,
                                      const char      bytchk ,
                                      const char      pad ,
                                      const char      reserved_2 ,
                                      const long int  parameter_list_length ,
                                      const char      reserved_6 ,
                                      const char      reserved_7 ,
                                      const char      reserved_8 ,
                                      const char      control_byte ,
                                      char           *scsi_command_length ,
                                      char            scsi_command[] ,
                                      int             scsi_command_size,
                                      char           *data_transfer);

#pragma IMS_nolink ( SCSI_Build_Copy_And_Verify_10 )
/*}}}  */
/*{{{  SCSI_Build_Inquiry_6*/
#pragma IMS_translate ( SCSI_Build_Inquiry_6 ,"SCSI.Build.Inquiry.6")

 void SCSI_Build_Inquiry_6 ( const char     lun ,
                             const char     reserved_1 ,
                             const char     evpd ,
                             const char     page_code ,
                             const char     reserved_3 ,
                             const char     allocation_length ,
                             const char     control_byte ,
                             char          *scsi_command_length ,
                             char           scsi_command[] ,
                             int            scsi_command_size,
                             char          *data_transfer);

#pragma IMS_nolink ( SCSI_Build_Inquiry_6 )
/*}}}  */
/*{{{  SCSI_Build_Log_Select_10*/
#pragma IMS_translate ( SCSI_Build_Log_Select_10 ,"SCSI.Build.Log.Select.10")

 void SCSI_Build_Log_Select_10 ( const char     lun ,
                                 const char     reserved_1 ,
                                 const char     pcr ,
                                 const char     sp ,
                                 const char     pc ,
                                 const char     reserved_2 ,
                                 const char     reserved_3 ,
                                 const char     reserved_4 ,
                                 const char     reserved_5 ,
                                 const char     reserved_6 ,
                                 const long int parameter_list_length ,
                                 const char     control_byte ,
                                 char          *scsi_command_length ,
                                 char           scsi_command[] ,
                                 int            scsi_command_size ,
                                 char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Log_Select_10 )
/*}}}  */
/*{{{  SCSI_Build_Log_Sense_10*/
#pragma IMS_translate ( SCSI_Build_Log_Sense_10 ,"SCSI.Build.Log.Sense.10")

 void SCSI_Build_Log_Sense_10 ( const char     lun ,
                                const char     reserved_1 ,
                                const char     ppc ,
                                const char     sp ,
                                const char     pc ,
                                const char     page_code ,
                                const char     reserved_3 ,
                                const char     reserved_4 ,
                                const long int parameter_pointer ,
                                const long int parameter_list_length ,
                                const char     control_byte ,
                                char          *scsi_command_length ,
                                char           scsi_command[],
                                int            scsi_command_size ,
                                char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Log_Sense_10 )
/*}}}  */
/*{{{  SCSI_Build_Mode_Select_6*/
#pragma IMS_translate ( SCSI_Build_Mode_Select_6 ,"SCSI.Build.Mode.Select.6")

 void SCSI_Build_Mode_Select_6 (  const char   len ,
                                  const char   pf ,
                                  const char   reserved_1 ,
                                  const char   sp ,
                                  const char   reserved_2 ,
                                  const char   reserved_3 ,
                                  const char   parameter_list_length ,
                                  const char   control_byte ,
                                  char        *scsi_command_length ,
                                  char         scsi_command[] ,
                                  int          scsi_command_size ,
                                  char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Mode_Select_6 )
/*}}}  */
/*{{{  SCSI_Build_Mode_Select_10*/
#pragma IMS_translate ( SCSI_Build_Mode_Select_10 ,"SCSI.Build.Mode.Select.10")

 void SCSI_Build_Mode_Select_10 ( const char     len ,
                                  const char     pf ,
                                  const char     reserved_1 ,
                                  const char     sp ,
                                  const char     reserved_2 ,
                                  const char     reserved_3 ,
                                  const char     reserved_4 ,
                                  const char     reserved_5 ,
                                  const char     reserved_6 ,
                                  const long int parameter_list_length ,
                                  const char     control_byte ,
                                  char          *scsi_command_length ,
                                  char           scsi_command[] ,
                                  int            scsi_command_size ,
                                  char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Mode_Select_10 )
/*}}}  */
/*{{{  SCSI_Build_Mode_Sense_6*/
#pragma IMS_translate ( SCSI_Build_Mode_Sense_6 ,"SCSI.Build.Mode.Sense.6")

 void SCSI_Build_Mode_Sense_6 (  const char    lun ,
                                 const char    reserved_1_4 ,
                                 const char    dbd ,
                                 const char    reserved_1_0 ,
                                 const char    pc ,
                                 const char    page_code ,
                                 const char    reserved_3 ,
                                 const char    allocation_length ,
                                 const char    control_byte ,
                                 char         *scsi_command_length ,
                                 char          scsi_command[] ,
                                 int           scsi_command_size ,
                                 char         *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Mode_Sense_6 )
/*}}}  */
/*{{{  SCSI_Build_Mode_Sense_10*/
#pragma IMS_translate ( SCSI_Build_Mode_Sense_10 ,"SCSI.Build.Mode.Sense.10")

 void SCSI_Build_Mode_Sense_10 ( const char      lun ,
                                 const char      reserved_1_4 ,
                                 const char      dbd ,
                                 const char      reserved_1_0 ,
                                 const char      pc ,
                                 const char      page_code ,
                                 const char      reserved_3 ,
                                 const char      reserved_4 ,
                                 const char      reserved_5 ,
                                 const char      reserved_6 ,
                                 const long int allocation_length ,
                                 const char      control_byte ,
                                 char           *scsi_command_length ,
                                 char            scsi_command[] ,
                                 int             scsi_command_size ,
                                 char           *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Mode_Sense_10 )
/*}}}  */
/*{{{  SCSI_Build_Read_Buffer_10*/
#pragma IMS_translate ( SCSI_Build_Read_Buffer_10 ,"SCSI.Build.Read.Buffer.10")

 void SCSI_Build_Read_Buffer_10 ( const char     lun ,
                                  const char     reserved_1_3 ,
                                  const char     mode ,
                                  const char     buffer_id ,
                                  const long int buffer_offset ,
                                  const long int allocation_length ,
                                  const char     control_byte ,
                                  char          *scsi_command_length ,
                                  char           scsi_command[] ,
                                  int            scsi_command_size ,
                                  char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Read_Buffer_10 )
/*}}}  */
/*{{{  SCSI_Build_Rx_Diagnostic_Results_6*/
#pragma IMS_translate ( SCSI_Build_Rx_Diagnostic_Results_6 ,"SCSI.Build.Rx.Diagnostic.Results.6")

 void SCSI_Build_Rx_Diagnostic_Results_6 ( const char     lun ,
                                           const char     reserved_1 ,
                                           const char     reserved_2 ,
                                           const long int allocation_length ,
                                           const char     control_byte ,
                                           char          *scsi_command_length ,
                                           char           scsi_command[] ,
                                           int            scsi_command_size ,
                                           char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Rx_Diagnostic_Results_6 )
/*}}}  */
/*{{{  SCSI_Build_Request_Sense_6*/
#pragma IMS_translate ( SCSI_Build_Request_Sense_6 ,"SCSI.Build.Request.Sense.6")

 void SCSI_Build_Request_Sense_6 ( const char   lun ,
                                   const char   reserved_1 ,
                                   const char   reserved_2 ,
                                   const char   reserved_3 ,
                                   const char   allocation_length ,
                                   const char   control_byte ,
                                   char        *scsi_command_length ,
                                   char         scsi_command[] ,
                                   int          scsi_command_size ,
                                   char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Request_Sense_6 )
/*}}}  */
/*{{{  SCSI_Build_Send_Diagnostic_6*/
#pragma IMS_translate ( SCSI_Build_Send_Diagnostic_6 ,"SCSI.Build.Send.Diagnostic.6")

 void SCSI_Build_Send_Diagnostic_6 ( const char     lun ,
                                     const char     pf ,
                                     const char     reserved_1 ,
                                     const char     selfTest ,
                                     const char     devofl ,
                                     const char     unitofl ,
                                     const char     reserved_2 ,
                                     const long int parameter_list_length ,
                                     const char     control_byte ,
                                     char          *scsi_command_length ,
                                     char           scsi_command[] ,
                                     int            scsi_command_size ,
                                     char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Send_Diagnostic_6 )
/*}}}  */
/*{{{  SCSI_Build_Test_Unit_Ready_6*/
#pragma IMS_translate ( SCSI_Build_Test_Unit_Ready_6 ,"SCSI.Build.Test.Unit.Ready.6")

 void SCSI_Build_Test_Unit_Ready_6 ( const char   lun ,
                                     const char   reserved_1 ,
                                     const char   reserved_2 ,
                                     const char   reserved_3 ,
                                     const char   reserved_4 ,
                                     const char   control_byte ,
                                     char        *scsi_command_length ,
                                     char         scsi_command[] ,
                                     int          scsi_command_size ,
                                     char        *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Test_Unit_Ready_6 )
/*}}}  */
/*{{{  SCSI_Build_Write_Buffer_10*/
#pragma IMS_translate ( SCSI_Build_Write_Buffer_10 ,"SCSI.Build.Write.Buffer.10")

 void SCSI_Build_Write_Buffer_10 ( const char     lun ,
                                   const char     reserved_1 ,
                                   const char     mode ,
                                   const char     buffer_id ,
                                   const long int buffer_offset ,
                                   const long int parameter_list_length ,
                                   const char     control_byte ,
                                   char          *scsi_command_length ,
                                   char           scsi_command[] ,
                                   int            scsi_command_size ,
                                   char          *data_transfer );

#pragma IMS_nolink ( SCSI_Build_Write_Buffer_10 )
/*}}}  */
/*}}}  */
/*{{{  Build & issue commands*/
/*{{{  SCSI_Change_definition_10*/
#pragma IMS_translate ( SCSI_Change_Definition_10 ,"SCSI.Change.Definition.10")

 void SCSI_Change_Definition_10 ( Channel    *to_scsi_ha ,
                                  Channel    *from_scsi_ha,
                                  const char  target_id ,
                                  const char  lun ,
                                  const char  save ,
                                  const char  defintion_parameter ,
                                  const char  parameter_data_length ,
                                  const char  control_byte ,
                                  const char  parameter_data[] ,
                                  int         parameter_data_size ,
                                  char       *msg_length ,
                                  char        message[] ,
                                  int         message_size ,
                                  char       *scsi_status ,
                                  short int    *execution_status );

#pragma IMS_nolink ( SCSI_Change_Definition_10 )
/*}}}  */
/*{{{  SCSI_Compare_10*/
#pragma IMS_translate ( SCSI_Compare_10 ,"SCSI.Compare.10")

 void SCSI_Compare_10 ( Channel       *to_scsi_ha ,
                        Channel       *from_scsi_ha ,
                        const char     target_id ,
                        const char     lun ,
                        const char     pad ,
                        const long int parameter_list_length ,
                        const char     control_byte ,
                        const char     parameter_list[] ,
                        int            parameter_list_size ,
                        char          *msg_length,
                        char           message[],
                        int            message_size,
                        char          *scsi_status,
                        short int       *execution_status );

#pragma IMS_nolink ( SCSI_Compare_10 )
/*}}}  */
/*{{{  SCSI_Copy_6*/
#pragma IMS_translate ( SCSI_Copy_6 ,"SCSI.Copy.6")

 void SCSI_Copy_6 ( Channel       *to_scsi_ha,
                    Channel       *from_scsi_ha,
                    const char     target_id,
                    const char     lun,
                    const char     pad,
                    const long int parameter_list_length,
                    const char     control_byte,
                    const char     parameter_list[],
                    int            parameter_list_size,
                    char          *msg_length,
                    char           message[],
                    int            message_size,
                    char          *scsi_status,
                    short int     *execution_status );

#pragma IMS_nolink ( SCSI_Copy_6 )
/*}}}  */
/*{{{  SCSI_Copy_And_Verify_10*/
#pragma IMS_translate ( SCSI_Copy_And_Verify_10 ,"SCSI.Copy.And.Verify.10")

 void SCSI_Copy_And_Verify_10 ( Channel       *to_scsi_ha,
                                Channel       *from_scsi_ha,
                                const char     target_id,
                                const char     lun,
                                const char     bytchk,
                                const char     pad,
                                const long int parameter_list_length,
                                const char     control_byte,
                                const char     parameter_list[],
                                int            parameter_list_size,
                                char          *msg_length,
                                char           message[],
                                int            message_size,
                                char          *scsi_status,
                                short int       *execution_status );

#pragma IMS_nolink ( SCSI_Copy_And_Verify_10 )
/*}}}  */
/*{{{  SCSI_Inquiry_6*/
#pragma IMS_translate ( SCSI_Inquiry_6 ,"SCSI.Inquiry.6")

 void SCSI_Inquiry_6 ( Channel    *to_scsi_ha ,
                       Channel    *from_scsi_ha,
                       const char  target_id,
                       const char  lun,
                       const char  evpd,
                       const char  page_code,
                       const char  allocation_length,
                       const char  control_byte,
                       char        inquiry_data[],
                       int         inquiry_data_size,
                       char       *msg_length,
                       char        message[],
                       int         message_size,
                       char       *scsi_status,
                       short int    *execution_status );

#pragma IMS_nolink ( SCSI_Inquiry_6 )
/*}}}  */
/*{{{  SCSI_Log_Select_10*/
#pragma IMS_translate ( SCSI_Log_Select_10 ,"SCSI.Log.Select.10")

 void SCSI_Log_Select_10 ( Channel       *to_scsi_ha ,
                           Channel       *from_scsi_ha,
                           const char     target_id,
                           const char     lun,
                           const char     pcr,
                           const char     sp,
                           const char     pc,
                           const long int parameter_list_length,
                           const char     control_byte,
                           const char     parameter_list[],
                           int            parameter_list_size,
                           char          *msg_length,
                           char           message[],
                           int            message_size,
                           char          *scsi_status,
                           short int       *execution_status );


#pragma IMS_nolink ( SCSI_Log_Select_10 )
/*}}}  */
/*{{{  SCSI_Log_Sense_10*/
#pragma IMS_translate ( SCSI_Log_Sense_10 ,"SCSI.Log.Sense.10")

 void SCSI_Log_Sense_10 ( Channel       *to_scsi_ha ,
                          Channel       *from_scsi_ha,
                          const char     target_id,
                          const char     lun,
                          const char     ppc,
                          const char     sp,
                          const char     pc,
                          const char     page_code,
                          const long int parameter_pointer,
                          const long int allocation_length,
                          const char     control_byte,
                          char           parameter_data[],
                          int            parameter_data_size,
                          char          *msg_length,
                          char           message[],
                          int            message_size,
                          char          *scsi_status,
                          short int       *execution_status );

#pragma IMS_nolink ( SCSI_Log_Sense_10 )
/*}}}  */
/*{{{  SCSI_Mode_Select_6*/
#pragma IMS_translate ( SCSI_Mode_Select_6 ,"SCSI.Mode.Select.6")

 void SCSI_Mode_Select_6 ( Channel    *to_scsi_ha ,
                           Channel    *from_scsi_ha,
                           const char  target_id,
                           const char  lun,
                           const char  pf,
                           const char  sp,
                           const char  parameter_list_length,
                           const char  control_byte,
                           const char  parameter_list[],
                           int         parameter_list_size,
                           char       *msg_length,
                           char        message[],
                           int         message_size,
                           char       *scsi_status,
                           short int    *execution_status );


#pragma IMS_nolink ( SCSI_Mode_Select_6 )
/*}}}  */
/*{{{  SCSI_Mode_Select_10*/
#pragma IMS_translate ( SCSI_Mode_Select_10 ,"SCSI.Mode.Select.10")

 void SCSI_Mode_Select_10 ( Channel       *to_scsi_ha ,
                            Channel       *from_scsi_ha,
                            const char     target_id,
                            const char     lun,
                            const char     pf,
                            const char     sp,
                            const long int parameter_list_length,
                            const char     control_byte,
                            const char     parameter_list[],
                            int            parameter_list_size,
                            char          *msg_length,
                            char           message[],
                            int            message_size,
                            char          *scsi_status,
                            short int       *execution_status );

#pragma IMS_nolink ( SCSI_Mode_Select_10 )
/*}}}  */
/*{{{  SCSI_Mode_Sense_6*/
#pragma IMS_translate ( SCSI_Mode_Sense_6 ,"SCSI.Mode.Sense.6")

 void SCSI_Mode_Sense_6 (  Channel    *to_scsi_ha ,
                           Channel    *from_scsi_ha,
                           const char  target_id,
                           const char  lun,
                           const char  dbd,
                           const char  pc,
                           const char  page_code,
                           const char  allocation_length,
                           const char  control_byte,
                           char        parameter_data[],
                           int         parameter_data_size,
                           char       *msg_length,
                           char        message[],
                           int         message_size,
                           char       *scsi_status,
                           short int    *execution_status );


#pragma IMS_nolink ( SCSI_Mode_Sense_6 )
/*}}}  */
/*{{{  SCSI_Mode_Sense_10*/
#pragma IMS_translate ( SCSI_Mode_Sense_10 ,"SCSI.Mode.Sense.10")

 void SCSI_Mode_Sense_10 ( Channel       *to_scsi_ha ,
                           Channel       *from_scsi_ha,
                           const char     target_id,
                           const char     lun,
                           const char     dbd,
                           const char     pc,
                           const char     page_code,
                           const long int allocation_length,
                           const char     control_byte,
                           char           parameter_data[],
                           int            parameter_data_size,
                           char          *msg_length,
                           char           message[],
                           int            message_size,
                           char          *scsi_status,
                           short int       *execution_status );


#pragma IMS_nolink ( SCSI_Mode_Sense_10 )
/*}}}  */
/*{{{  SCSI_Read_Buffer_10*/
#pragma IMS_translate ( SCSI_Read_Buffer_10 ,"SCSI.Read.Buffer.10")

 void SCSI_Read_Buffer_10 ( Channel       *to_scsi_ha ,
                            Channel       *from_scsi_ha,
                            const char     target_id,
                            const char     lun,
                            const char     mode,
                            const char     buffer_id,
                            const long int buffer_offset,
                            const long int allocation_length,
                            const char     control_byte,
                            char           device_buffer[],
                            int            device_Buffer_size,
                            char          *msg_length,
                            char           message[],
                            int            message_size,
                            char          *scsi_status,
                            short int       *execution_status );


#pragma IMS_nolink ( SCSI_Read_Buffer_10 )
/*}}}  */
/*{{{  SCSI_Request_Sense_6*/
#pragma IMS_translate ( SCSI_Request_Sense_6 ,"SCSI.Request.Sense.6")

 void SCSI_Request_Sense_6 ( Channel    *to_scsi_ha ,
                             Channel    *from_scsi_ha,
                             const char  target_id,
                             const char  lun,
                             const char  allocation_length,
                             const char  control_byte,
                             char        request_Sense_data[],
                             int         request_Sense_data_size,
                             char       *msg_length,
                             char        message[],
                             int         message_size,
                             char       *scsi_status,
                             short int    *execution_status );


#pragma IMS_nolink ( SCSI_Request_Sense_6 )
/*}}}  */
/*{{{  SCSI_Rx_Diagnostics_6*/
#pragma IMS_translate ( SCSI_Rx_Diagnostics_6 ,"SCSI.Rx.Diagnostics.6")

 void SCSI_Rx_Diagnostics_6 ( Channel       *to_scsi_ha ,
                              Channel       *from_scsi_ha,
                              const char     target_id,
                              const char     lun,
                              const long int allocation_length,
                              const char     control_byte,
                              char           diagnostic_results[],
                              int            diagnostic_results_size,
                              char          *msg_length,
                              char           message[],
                              int            message_size,
                              char          *scsi_status,
                              short int       *execution_status );


#pragma IMS_nolink ( SCSI_Rx_Diagnostics_6 )
/*}}}  */
/*{{{  SCSI_Send_Diagnostic_6*/
#pragma IMS_translate ( SCSI_Send_Diagnostic_6 ,"SCSI.Send.Diagnostic.6")

 void SCSI_Send_Diagnostic_6 ( Channel       *to_scsi_ha ,
                               Channel       *from_scsi_ha,
                               const char     target_id,
                               const char     lun,
                               const char     pf,
                               const char     self_test,
                               const char     devofl,
                               const char     unitofl,
                               const long int parameter_list_length,
                               const char     control_byte,
                               const char     parameter_list[],
                               int            parameter_list_size,
                               char          *msg_length,
                               char           message[],
                               int            message_size,
                               char          *scsi_status,
                               short int       *execution_status );


#pragma IMS_nolink ( SCSI_Send_Diagnostic_6 )
/*}}}  */
/*{{{  SCSI_Test_Unit_Ready_6*/
#pragma IMS_translate ( SCSI_Test_Unit_Ready_6 ,"SCSI.Test.Unit.Ready.6")

 void SCSI_Test_Unit_Ready_6 ( Channel    *to_scsi_ha ,
                               Channel    *from_scsi_ha,
                               const char  target_id,
                               const char  lun,
                               const char  control_byte,
                               char       *msg_length,
                               char        message[],
                               int         message_size,
                               char       *scsi_status,
                               short int    *execution_status );


#pragma IMS_nolink ( SCSI_Test_Unit_Ready_6 )
/*}}}  */
/*{{{  SCSI_Write_Buffer_10*/
#pragma IMS_translate ( SCSI_Write_Buffer_10 ,"SCSI.Write.Buffer.10")

 void SCSI_Write_Buffer_10 ( Channel       *to_scsi_ha ,
                             Channel       *from_scsi_ha,
                             const char     target,
                             const char     lun,
                             const char     mode,
                             const char     buffer_id,
                             const long int buffer_offset,
                             const long int parameter_list_length,
                             const char     control_byte,
                             const char     parameter_list[],
                             int            parameter_list_size,
                             char          *msg_length,
                             char           message[],
                             int            message_size,
                             char          *scsi_status,
                             short int       *execution_status );


#pragma IMS_nolink ( SCSI_Write_Buffer_10 )
/*}}}  */
/*}}}  */
