/*{{{  Header */
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992"  */
/*#COMMENT "IMS F002C Product release SCSI software libraries"; */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 04-Apr-1990 */
/* */
/* File Name   : scsicmnd.h */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Version     : 1.0 */
/* */
/* Division    : IQ Systems */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : Definition of SCSI-2 Operation Codes as defined in SCSI-2 */
/*               Working Draft Proposal Revision 8. */
/* */
/*------------------------------------------------------------------------------ */
/* Schedule of Amendments */
/*------------------------------------------------------------------------------ */
/* */
/*------------------------------------------------------------------------------ */
/*}}}   */
/*{{{  6  Byte Commands */
const char Test_Unit_Ready_6  = 0x00;
const char Rewind_6  = 0x01;
const char Rezero_Unit_6  = 0x01;
const char Request_Sense_6  = 0x03;
const char Format_6  = 0x04;
const char Format_Unit_6  = 0x04;
const char Read_Block_Limits_6  = 0x05;
const char Initialize_Element_Status_6  = 0x07;
const char Initialise_Element_Status_6  = 0x07;/*This side of pond! */
const char Reassign_Blocks_6  = 0x07;
const char Get_Message_6  = 0x08;
const char Read_6  = 0x08;
const char Receive_6  = 0x08;
const char Print_6  = 0x0A;
const char Send_6  = 0x0A;
const char Send_Message_6  = 0x0A;
const char Write_6  = 0x0A;
const char Seek_6  = 0x0B;
const char Slew_and_Print_6  = 0x0B;
const char Read_Reverse_6  = 0x0F;
const char Synchronize_Buffer_6  = 0x10;
const char Write_Filemarks_6  = 0x10;
const char Write_Filemark_6  = 0x10;
const char Space_6  = 0x11;
const char Inquiry_6  = 0x12;
const char Verify_6  = 0x13;
const char Recover_Buffered_Data_6  = 0x14;
const char Mode_Select_6  = 0x15;
const char Reserve_6  = 0x16;
const char Reserve_Unit_6  = 0x16;
const char Release_6  = 0x17;
const char Release_Unit_6  = 0x17;
const char Copy_6  = 0x18;
const char Erase_6  = 0x19;
const char Mode_Sense_6  = 0x1A;
const char Load_Unload_6  = 0x1B;
const char Scan_6  = 0x1B;
const char Stop_Print_6  = 0x1B;
const char Start_Stop_Unit_6  = 0x1B;
const char Receive_Diagnostic_Results_6  = 0x1C;
const char Send_Diagnostic_6  = 0x1D;
const char Prevent_Allow_Medium_Removal_6  = 0x1E;
/*}}}   */
/*{{{  10 Byte Commands */
const char Define_Window_Parameters_10  = 0x24;
const char Get_Window_Parameters_10  = 0x25;
const char Read_Capacity_10  = 0x25;
const char Read_CD_ROM_Capacity_10  = 0x25;
const char Read_10  = 0x28;
const char Get_Message_10  = 0x28;
const char Read_Generation  = 0x29; /*Listed not defined */
const char Send_10  = 0x2A;
const char Send_Message_10  = 0x2A;
const char Write_10  = 0x2A;
const char Locate_10  = 0x2B;
const char Position_to_Element_10  = 0x2B;
const char Seek_10  = 0x2B;
const char Erase_10  = 0x2C;
const char Read_Updated_Block_10  = 0x2D;
const char Write_and_Verify_10  = 0x2E;
const char Verify_10  = 0x2F;
const char Search_Data_High_10  = 0x30;
const char Medium_Position  = 0x30; /*Listed not defined */
const char Search_Data_Equal_10  = 0x31;
const char Search_Data_Low_10  = 0x32;
const char Set_Limits_10  = 0x33;
const char Get_Data_Status_10  = 0x34;
const char Pre_Fetch_10  = 0x34;
const char Read_Position_10  = 0x34;
const char Synchronize_Cache_10  = 0x35;
const char Lock_Unlock_Cache_10  = 0x36;
const char Read_Defect_Data_10  = 0x37;
const char Medium_Scan_10  = 0x38;
const char Compare_10  = 0x39;
const char Copy_and_Verify_10  = 0x3A;
const char Write_Buffer_10  = 0x3B;
const char Read_Buffer_10  = 0x3C;
const char Update_Block_10  = 0x3D;
const char Read_Long_10  = 0x3E;
const char Write_Long_10  = 0x3F;
const char Change_Definition_10  = 0x40;
const char Write_Same_10  = 0x41;
const char Read_Sub_Channel_10  = 0x42;
const char Read_TOC_10  = 0x43;
const char Read_Header_10  = 0x44;
const char Play_Audio_10  = 0x45;
const char Play_Audio_MSF_10  = 0x47;
const char Play_Audio_Track_Index_10  = 0x48;
const char Play_Audio_Track_Relative_10  = 0x49; /* Naming */
const char Play_Track_Relative_10  = 0x49; /* Discrepency */
const char Pause_Resume_10  = 0x4B;
const char Log_Select_10  = 0x4C;
const char Log_Sense_10  = 0x4D;
const char Mode_Select_10  = 0x55;
const char Mode_Sense_10  = 0x5A;
/*}}}   */
/*{{{  12 Byte Commands */
const char Move_Medium_12  = 0xA5;
const char Play_Audio_12  = 0xA5;
const char Exchange_Medium_12  = 0xA6;
const char Get_Message_12  = 0xA8;
const char Read_12  = 0xA8;
const char Play_Audio_Track_Relative_12  = 0xA9; /* Naming */
const char Play_Track_Relative_12  = 0xA9; /* Discrepency */
const char Send_Message_12  = 0xAA;
const char Write_12  = 0xAA;
const char Erase_12  = 0xAC;
const char Write_and_Verify_12  = 0xAE;
const char Verify_12  = 0xAF;
const char Search_Data_High_12  = 0xB0;
const char Search_Data_Equal_12  = 0xB1;
const char Search_Data_Low_12  = 0xB2;
const char Set_Limits_12  = 0xB3;
const char Request_Volume_Element_Address_12  = 0xB5;
const char Send_Volume_Tag_12  = 0xB6;
const char Read_Defect_Data_12  = 0xB7;
const char Read_Element_Status_12  = 0xB8;
/*}}}   */
/*{{{  Buffer Sizes */
#define Command_Max                        256
/*}}}   */
/*{{{  Frequently used definitions */
const char SCSI_Non_Linked_Command  = (char) 0x00;
const char SCSI_Linked_Command  = (char) 0x01;
const char SCSI_Linked_Command_With_Flag  = (char) 0x03;
/*}}}   */
