/*{{{  Header */
/*#COMMENT "Copyright INMOS Limited 1990, 1991, 1992" */
/*#COMMENT "IMS F002C Product release SCSI software libraries" */
/*------------------------------------------------------------------------------ */
/* */
/* Date        : 04-Apr-1990 */
/* */
/* File Name   : SCSIMSGS.H */
/* */
/* Project     : F002 - SCSI Tram Software */
/* */
/* Division    : IQ Systems */
/* */
/* Version     : 1.0 */
/* */
/* Limitations : This software may be distributed in source form. */
/* */
/* Description : Definitions for SCSI-2 message system as defined in SCSI-2 */
/*               Working Draft Proposal Revision 8. */
/* */
/* The SCSI Message system allows communication between an initiator and target */
/* for the purpose of interface management. A message may be one, two, or */
/* multiple bytes in length. One or more messages may be sent during a single */
/* MESSAGE phase, but a message may not be split over MESSAGE phases. The */
/* initiator is required to end the MESSAGE OUT phase when it sends certain */
/* messages identified in Table 5-2 of the SCSI-2 specification. */
/* */
/*------------------------------------------------------------------------------ */
/* Schedule of Amendments */
/*------------------------------------------------------------------------------ */
/* */
/*------------------------------------------------------------------------------ */
/*}}}  */
/*{{{  Non Extended Messages */
#define Abort                                 0x0006
#define Abort_Tag                             0x000D
#define Bus_Device_Reset                      0x000C
#define Clear_Queue                           0x000E
#define Command_Complete                      0x0000
#define Disconnect                            0x0004
#define Identify_No_Disconnect                0x00A0
#define Identify_Lun_0_No_Disconnect          0x0080
#define Identify_Lun_1_No_Disconnect          0x0081
#define Identify_Lun_2_No_Disconnect          0x0082
#define Identify_Lun_3_No_Disconnect          0x0083
#define Identify_Lun_4_No_Disconnect          0x0084
#define Identify_Lun_5_No_Disconnect          0x0085
#define Identify_Lun_6_No_Disconnect          0x0086
#define Identify_Lun_7_No_Disconnect          0x0087
#define Identify_With_Disconnect              0x00E0
#define Identify_Lun_0_With_Disconnect        0x00C0
#define Identify_Lun_1_With_Disconnect        0x00C1
#define Identify_Lun_2_With_Disconnect        0x00C2
#define Identify_Lun_3_With_Disconnect        0x00C3
#define Identify_Lun_4_With_Disconnect        0x00C4
#define Identify_Lun_5_With_Disconnect        0x00C5
#define Identify_Lun_6_With_Disconnect        0x00C6
#define Identify_Lun_7_With_Disconnect        0x00C7
#define Ignore_Wide_Residue                   0x0023
#define Initiate_Recovery                     0x000F
#define Initiator_Detected_Error              0x0005
#define Linked_Command_Complete               0x000A
#define Linked_Command_Complete_With_Flag     0x000B
#define Message_Parity_Error                  0x0009
#define Message_Reject                        0x0007
#define No_Operation                          0x0008
#define Head_of_Queue_Tag                     0x0021
#define Ordered_Queue_Tag                     0x0022
#define Simple_Queue_Tag                      0x0020
#define Release_Recovery                      0x0010
#define Restore_Pointers                      0x0003
#define Save_Data_Pointer                     0x0002
#define Terminate_IO_Process                  0x0011
/*}}}  */
/*{{{  Extended Messages */
#define Extended_Message                      0x0001

#define Modify_Data_Pointer                   0x0000
#define Synchronous_Data_Transfer_Request     0x0001
#define SCSI_1_Extended_Identify              0x0002
#define Wide_Data_Transfer_Request            0x0003
/*}}}  */
/*{{{  SCSI Status Definitions */
#define SCSI_Status_Good                            0x0000
#define SCSI_Status_Check_Condition                 0x0002
#define SCSI_Status_Condition_Met_Good              0x0004
#define SCSI_Status_Busy                            0x0008
#define SCSI_Status_Intermediate_Good               0x0010
#define SCSI_Status_Intermediate_Condition_Met_Good 0x0014
#define SCSI_Status_Reservation_Conflict            0x0018
#define SCSI_Status_Command_Terminated              0x0022
#define SCSI_Status_Queue_Full                      0x0028
/*}}}  */
/*{{{  Message Buffer Size Definitions */
#define Message_Max                                     256
/*}}}  */

