--{{{  Header
#COMMENT "Copyright INMOS Limited 1990, 1991, 1992"
#COMMENT "IMS F002C Product release SCSI software libraries"
--------------------------------------------------------------------------------
--
-- Date        : 04-Apr-1990
--
-- File Name   : SCSIMSGS.INC
--
-- Project     : F002 - SCSI Tram Software
--
-- Division    : IQ Systems
--
-- Version     : 1.0
--
-- Limitations : This software may be distributed in source form.
--
-- Description : Definitions for SCSI-2 message system as defined in SCSI-2
--               Working Draft Proposal Revision 8.
--
-- The SCSI Message system allows communication between an initiator and target
-- for the purpose of interface management. A message may be one, two, or
-- multiple bytes in length. One or more messages may be sent during a single
-- MESSAGE phase, but a message may not be split over MESSAGE phases. The
-- initiator is required to end the MESSAGE OUT phase when it sends certain
-- messages identified in Table 5-2 of the SCSI-2 specification.
--
--------------------------------------------------------------------------------
-- Schedule of Amendments
--------------------------------------------------------------------------------
--
--------------------------------------------------------------------------------
--}}}  
--{{{  Non Extended Messages
VAL Abort                                 IS #0006:
VAL Abort.Tag                             IS #000D:
VAL Bus.Device.Reset                      IS #000C:
VAL Clear.Queue                           IS #000E:
VAL Command.Complete                      IS #0000:
VAL Disconnect                            IS #0004:
VAL Identify.No.Disconnect                IS #00A0:
VAL Identify.Lun.0.No.Disconnect          IS #0080:
VAL Identify.Lun.1.No.Disconnect          IS #0081:
VAL Identify.Lun.2.No.Disconnect          IS #0082:
VAL Identify.Lun.3.No.Disconnect          IS #0083:
VAL Identify.Lun.4.No.Disconnect          IS #0084:
VAL Identify.Lun.5.No.Disconnect          IS #0085:
VAL Identify.Lun.6.No.Disconnect          IS #0086:
VAL Identify.Lun.7.No.Disconnect          IS #0087:
VAL Identify.With.Disconnect              IS #00E0:
VAL Identify.Lun.0.With.Disconnect        IS #00C0:
VAL Identify.Lun.1.With.Disconnect        IS #00C1:
VAL Identify.Lun.2.With.Disconnect        IS #00C2:
VAL Identify.Lun.3.With.Disconnect        IS #00C3:
VAL Identify.Lun.4.With.Disconnect        IS #00C4:
VAL Identify.Lun.5.With.Disconnect        IS #00C5:
VAL Identify.Lun.6.With.Disconnect        IS #00C6:
VAL Identify.Lun.7.With.Disconnect        IS #00C7:
VAL Ignore.Wide.Residue                   IS #0023:
VAL Initiate.Recovery                     IS #000F:
VAL Initiator.Detected.Error              IS #0005:
VAL Linked.Command.Complete               IS #000A:
VAL Linked.Command.Complete.With.Flag     IS #000B:
VAL Message.Parity.Error                  IS #0009:
VAL Message.Reject                        IS #0007:
VAL No.Operation                          IS #0008:
VAL Head.of.Queue.Tag                     IS #0021:
VAL Ordered.Queue.Tag                     IS #0022:
VAL Simple.Queue.Tag                      IS #0020:
VAL Release.Recovery                      IS #0010:
VAL Restore.Pointers                      IS #0003:
VAL Save.Data.Pointer                     IS #0002:
VAL Terminate.IO.Process                  IS #0011:
--}}}  
--{{{  Extended Messages
VAL Extended.Message                      IS #0001:

VAL Modify.Data.Pointer                   IS #0000:
VAL Synchronous.Data.Transfer.Request     IS #0001:
VAL SCSI.1.Extended.Identify              IS #0002:
VAL Wide.Data.Transfer.Request            IS #0003:
--}}}  
--{{{  SCSI Status Definitions
VAL SCSI.Status.Good                            IS #0000:
VAL SCSI.Status.Check.Condition                 IS #0002:
VAL SCSI.Status.Condition.Met.Good              IS #0004:
VAL SCSI.Status.Busy                            IS #0008:
VAL SCSI.Status.Intermediate.Good               IS #0010:
VAL SCSI.Status.Intermediate.Condition.Met.Good IS #0014:
VAL SCSI.Status.Reservation.Conflict            IS #0018:
VAL SCSI.Status.Command.Terminated              IS #0022:
VAL SCSI.Status.Queue.Full                      IS #0028:
--}}}  
--{{{  Message Buffer Size Definitions
VAL INT Message.Max                                     IS 256:
--}}}  
